defmodule Burox.Mixfile do
    use Mix.Project

  def project do
    [
      app: :buroxxx,
      version: "0.3.2",
      elixir: "~> 1.7",
      start_permanent: Mix.env() == :prod,
      deps: deps(),
      # Docs
      name: "Burox Custom",
      package: package(),
      description: "Yaju",
      source_url: "https://gitlab.gendra.mx/open-source/burox",
      homepage_url: "https://gitlab.gendra.mx/open-source/burox",
      docs: [
        main: "Burox"
      ]
    ]
  end

  defp package() do
    [
      # This buroxxx is only needed when you don't want to use the OTP application name
      name: "buroxxx",
      # These are the default files included in the package
      licenses: ["The MIT License (MIT)"],
      links: %{"GitHub" => "https://github.com/elixir-ecto/postgrex"}
    ]
  end

  def application do
    [
      extra_applications: [:logger]
    ]
  end

  defp deps do
    [
      {:credo, "~> 0.10.0", only: [:dev, :test], runtime: false},
      {:ex_doc, "~> 0.19", only: :dev, runtime: false},
      {:socket, "~> 0.3.2"},
      {:mox, "~> 0.4", only: :test},
      {:vex, "~> 0.7"}
    ]
  end
end
